import datetime
import sys
import sys,os,time
os.chdir('/www/server/panel/')
sys.path.insert(0,"class/")
import public

# Check if log file path is provided as command line argument
if len(sys.argv) != 2:
    print("Usage: python log_task_analyzer.py <log_file_path>")
    sys.exit(1)

# Log file path from command line argument
log_file = sys.argv[1]

# File to record task execution status
task_log = "/tmp/task_log.log"

# Read the log file in reverse order
try:
    with open(log_file, 'r', encoding='utf-8', errors='ignore') as f:
        lines = f.readlines()[::-1]
except FileNotFoundError:
    print(f"Log file {log_file} not found.")
    sys.exit(1)

# Initialize variables
found_successful = False
found_error_before_next_successful = False

# Error patterns to look for
error_patterns = ["错误", "失败","command not found","Unknown error","不存在","请先到软件商店安装日志清理工具","failed to run command","No such file or directory","not supported or disabled in libcurl"]


# Iterate through the log
for line in lines:
    if "Successful" in line:
        if found_successful:
            # If the second "Successful" is found, stop searching
            break
        else:
            # Found the first "Successful"
            found_successful = True
    elif any(error_pattern in line for error_pattern in error_patterns) and found_successful:
        # If any error pattern is found after finding "Successful", mark the error
        found_error_before_next_successful = True
        break

# Log based on findings
with open(task_log, 'a') as f:
    current_time = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    if found_successful and found_error_before_next_successful:
        # 日志记录操作
        f.write(f"{current_time} - 最后一次定时任务执行发现错误，执行失败\n")
        # 提取 echo 值作为日志文件名的前缀
        echo_value = log_file.split('/')[-1].split('.')[0]
        crontab_data_list = public.M('crontab').where('echo=?', (echo_value,)).select()
        if crontab_data_list:
            public.M('crontab').where('echo=?', (echo_value,)).setField('result', 0)

        f.write(f"{current_time} - 最后一次定时任务执行发现错误，执行失败\n")
    else:
        f.write(f"{current_time} - 最后一次定时任务执行成功\n")
